library ieee;
use ieee.std_logic_1164.all;

entity evb_pal is 
	port(
	  Addr		: in std_logic_vector(15 downto 10);
	  nRD		: in std_logic;
	  nWR		: in std_logic;
	  nRAMCS	: out std_logic;
	  nCS_IINCHIP 	: out std_logic;
	  LCDCS		: out std_logic
	);

ATTRIBUTE pin_numbers of evb_pal:ENTITY IS
"Addr(15):6 "
& "Addr(14):5 "
& "Addr(13):4 "
& "Addr(12):3 "
& "Addr(11):2 "
& "Addr(10):1 "
& "nRD:7 "
& "nWR:8 "
& "nRAMCS:12 "
& "LCDCS:13 "
& "nCS_IINCHIP:14 ";
end evb_pal;

architecture arch_evb_pal of evb_pal is
begin

  --nRAMCS (0x0000 - 0x7fff) : 
  process(Addr)
  begin
    if ((Addr >= "000000") and (Addr < "100000")) then
      nRAMCS <= '0';
	else
      nRAMCS <= '1';
	end if;
  end process;


  --LCDCS (0x9000 - 0x93ff)
  process(Addr, nRD, nWR)
  begin
    if (((Addr >= "100100") and (Addr < "100101")) and (nRD = '0' or nWR = '0')) then
      LCDCS <= '1';
	else
      LCDCS <= '0';
	end if;
  end process;



-- IINCHIP (0x8000 - 0x8800, 0xC000 - 0xFFFF)
process(Addr)
  begin
    if (((Addr >= "100000") and (Addr < "100010")) or (Addr >= "110000")) then
	  nCS_IINCHIP <= '0';
	else
	  nCS_IINCHIP <= '1';
	end if;
  end process;


end arch_evb_pal;


